
.globl log, _log
.globl fpsim, fpsr, m.ext, m.lngi       / Floating point  stuff

/  This routine was converted to call the floating point
/  simulator directly 1-14-76 (rfb of ucsdcdcfs)

	jsr     pc, fpsim       / call floating point simulator
ldfps = 170100^tst
	jsr     pc, fpsim       / call floating point simulator
stfps = 170200^tst
/
/       log accepts its argument and returns its result
/       in fr0.  the carry bit is set if the argument is
/       zero or negative.
/       the coefficients are #2705 from hart & cheney.
/
	jsr     pc, fpsim       / call floating point simulator
/       movf    arg,fr0
/       jsr     pc,log
	jsr     pc, fpsim       / call floating point simulator
/       movf    fr0,...
/
_log:
	mov     r5,-(sp)
	mov     sp,r5
	jsr     pc, fpsim       / call floating point simulator
	movf    4(r5),fr0
	jsr     pc,log
	mov     (sp)+,r5
	rts     pc

log:
	jsr     pc, fpsim       / call floating point simulator
	tstf    fr0
	jsr     pc, fpsim       / call floating point simulator
	cfcc
	bgt     1f
	jsr     pc, fpsim       / call floating point simulator
	movf    $bigneg,fr0     /return -(big) on error
	sec
	rts     pc
1:
	jsr     pc, fpsim       / call floating point simulator
	stfps   -(sp)
	jsr     pc, fpsim       / call floating point simulator
	ldfps   $200            /di mode
	jsr     pc, fpsim       / call floating point simulator
	movf    fr2,-(sp)
	jsr     pc, fpsim       / call floating point simulator
	movf    fr1,-(sp)
/
	jsr     pc, fpsim       / call floating point simulator
	movei   fr0,-(sp)       /scale
	jsr     pc, fpsim       / call floating point simulator
	movie   $0,fr0
	jsr     pc, fpsim       / call floating point simulator
	cmpf    sqrt2o2,fr0
	jsr     pc, fpsim       / call floating point simulator
	cfcc
	blt     1f
	jsr     pc, fpsim       / call floating point simulator
	movie   $1,fr0
	dec     (sp)
1:
	jsr     pc, fpsim       / call floating point simulator
	movf    fr0,fr1         /(1/2)^(1/2) < x < 2^(1/2)
	jsr     pc, fpsim       / call floating point simulator
	subf    $one,fr0
	jsr     pc, fpsim       / call floating point simulator
	addf    $one,fr1
	jsr     pc, fpsim       / call floating point simulator
	divf    fr1,fr0         /z = (x-1)/(x+1)
	jsr     pc, fpsim       / call floating point simulator
	movf    fr0,fr1
	jsr     pc, fpsim       / call floating point simulator
	mulf    fr0,fr1         /z^2
/
	jsr     pc, fpsim       / call floating point simulator
	movf    p3,fr2
	jsr     pc, fpsim       / call floating point simulator
	mulf    fr1,fr2
	jsr     pc, fpsim       / call floating point simulator
	addf    p2,fr2
	jsr     pc, fpsim       / call floating point simulator
	mulf    fr1,fr2
	jsr     pc, fpsim       / call floating point simulator
	addf    p1,fr2
	jsr     pc, fpsim       / call floating point simulator
	mulf    fr1,fr2
	jsr     pc, fpsim       / call floating point simulator
	addf    p0,fr2
	jsr     pc, fpsim       / call floating point simulator
	mulf    fr2,fr0         /zp(z)
/
	jsr     pc, fpsim       / call floating point simulator
	movf    fr1,fr2
	jsr     pc, fpsim       / call floating point simulator
	addf    q2,fr2
	jsr     pc, fpsim       / call floating point simulator
	mulf    fr1,fr2
	jsr     pc, fpsim       / call floating point simulator
	addf    q1,fr2
	jsr     pc, fpsim       / call floating point simulator
	mulf    fr1,fr2
	jsr     pc, fpsim       / call floating point simulator
	addf    q0,fr2          /q(z)
/
	jsr     pc, fpsim       / call floating point simulator
	divf    fr2,fr0         /zp(z)/q(z)
	jsr     pc, fpsim       / call floating point simulator
	movif   (sp)+,fr1
	jsr     pc, fpsim       / call floating point simulator
	mulf    log2,fr1
	jsr     pc, fpsim       / call floating point simulator
	addf    fr1,fr0
/
	jsr     pc, fpsim       / call floating point simulator
	movf    (sp)+,fr1
	jsr     pc, fpsim       / call floating point simulator
	movf    (sp)+,fr2
	jsr     pc, fpsim       / call floating point simulator
	ldfps   (sp)+
	rts     pc
/
/
one     = 40200
bigneg  = 177777
/
.data
sqrt2o2: 40065; 02363; 31771; 157145
log2:    40061; 71027;173721;147572
/
p0:     141300; 16201; 02154; 10216
p1:      41367;124211; 21611;114442
p2:     141032; 31773; 64222; 40261
p3:      37727;114303;110107;114145
/
q0:     141100; 16201; 02154; 10216
q1:      41233;154404;136454; 22153
q2:     141016;111747; 07541; 52530
/
/
/p0 = -.24013 91795 59210 50986 8484  d2
/p1 =  .30957 29282 15376 50062 264   d2
/p2 = -.96376 90933 68686 59324       d1
/p3 =  .42108 73712 17979 7145        d0
/
/q0 = -.12006 95897 79605 25471 7525  d2
/q1 =  .19480 96607 00889 73051 623   d2
/q2 = -.89111 09027 93783 12337       d1
/q3 =  .1                             d1
/

