/	This set of routines (that link with c or f4p)
/	are used to drive the zeta driver.
/	The whole idea here is to eliminate the huge
/	amount of data and programs the the GD zeta occupies.
/	Therefore, this stuff pipes to a seperate program that 
/	does the Grunt Work.
/ 
/	Forrest W. Howard Jr.
/	Commercial Union Leasing Corp.
/	11/ 30/ 76
/ 
/ 
/	leftarrow is set by the header file as:
/	0 for c
/	1 for macro
/ 
/	Below are the routines.... the destructive ones
/	are indicated with a *
/	non-user callable are indicated with a c after the 
/	"/ "
/ 
/ 
/ 
/	subroutine plots(itrans)
/	subroutine plotf(itrans,ldev)
/	subroutine plotfs(itrans,'string',lsize)
/	plotfs(itrans,"cstring")
/ 
/	subroutine pon
/	subroutine cline
/	subroutine sline
/ 
/	subroutine poff
/	subroutine ton			/ must Wait
/ 
/	subroutine plot36(sizei)
/	subroutine factor(fact1)
/ 
/	subroutine line(xarr,yarr,npts1,inc1,ndp,is1)
/	subroutine offset(xo,xf,yo,yf)
/	subroutine plot(x,y,int)	/ half funny
/ *	subroutine scale(array,axlen,npts,inc1)
/ *	subroutine where(x,y,fact1)
/	subroutine smode(ifa,asp)
/	subroutine speed(i,iarr)
/	subroutine axis(xpage,ypage,mesbuf,nchar1,axlen,angl1,
/	subroutine iaxis(xpage,ypage,mesbuf,nchar1,axlen,angl1,
/	subroutine symbol(x1,y1,size1,mesbuf,angle,ibsiz)
/	subroutine number(x,y,size1,fnum1,angle,ndec1)
 cplotfs=1
 ccline=2
 Cline=4		/ conflict.....
 cplot=6
 cplots=10
 cpon=12
 csline=14
 cplot36=16
 cton=20
 caxis=22
 ciaxis=25
 cnumber=24
 coffset=5
 cpoff=11		/ not destructive, but must Wait
 cwhere=15
 cspeed=21
 cfactor=3
 cscale=13
 csymbol=23
 csmode=17
 cplotf=7
/ 
/	The following three routines are in charge of
/	starting up the whole mess.  They fork+exec
/	a child, and pass the initial arguements.
/	they also fix up pipes to+fro the plotter process
/ 
/	subroutine plots(itrans)
.if	leftarrow
_plots:
.endif

.if	leftarrow-1
plots:
.endif

	jsr	pc,pltinit
	mov	$cplots,r0
	jbr	i

/	subroutine plotf(itrans,ldev)
.if	leftarrow
_plotf:
.endif

.if	leftarrow-1
plotf:
.endif

	jsr	pc,pltinit
	mov	$cplotf,r0
	jbr	ii
/	subroutine plotfs(itrans,'string',lsize)
/	int plotfs(int,string)
.if	leftarrow
_plotfs:
	mov	4(sp),r0
	mov	r0,r1
1:	tstb	(r1)+
	bne	1b
	sub	r0,r1		/ length of string
	mov	r1,-(sp)
	mov	r0,-(sp)
	mov	6(sp),-(sp)
	mov	1f,-(sp)
	br	2f
1:	add	$6,sp		/ and off the gargbage
	rts	pc		/ now is up to c
2:				/ the routine now, with length in r0
.endif

.if	leftarrow-1
plotfs:
	mov	*6(r5),r1	/ also length of string
.endif

	inc	r1		/ child will play with nulls
	mov	r1,-(sp)
	jsr	pc,pltinit
	mov	(sp)+,r1	/ conserve r1
	mov	$cplotfs,r0
	jbr	iCi		/ int-Char array-int
/ 
/ 
/	subroutine plot(x,y,i)
/ 
.if	leftarrow
_plot:	mov	22(sp),r1
.endif

.if	leftarrow-1
plot:	mov	*6(r5),r1
.endif

	mov	$cplot,r0
	cmp	r1,$999.
	jeq	ffie		/ float float int end
	jbr	ffi		/ float,float,int
/	subroutine pon
.if	leftarrow
_pon:
.endif

.if	leftarrow-1
pon:
.endif

	mov	$cpon,r0
	jbr	noargs


/	subroutine cline
.if	leftarrow
_cline:
.endif

.if	leftarrow-1
cline:
.endif

	mov	$ccline,r0
	jbr	noargs
/ 
/ 
/	subroutine sline
.if	leftarrow
_sline:
.endif

.if	leftarrow-1
sline:
.endif

	mov	$csline,r0
	jbr	noargs
/ 
/	The following two routines MUST Wait.....
/	subroutine poff
/	subroutine ton
.if	leftarrow
_poff:	mov	$cpoff,r0
	br	1f

_ton:	mov	$cton,r0
.endif


.if	leftarrow-1
poff:	mov	$cpoff,r0
	br	1f
ton:	mov	$cton,r0
.endif

1:	mov	$fltdmp,r1
	mov	$recbuf,(r1)
	mov	(r1)+,(r1)
	mov	(r1)+,(r1)
	jbr	noargs_w


/ 
/	The following two routines take one float
/	subroutine plot36(sizei)
/	subroutine factor(fact1)
.if	leftarrow
_plot36:
	mov	$cplot36,r0
	jbr	f			/ one float
_factor:
	mov	$cfactor,r0
	jbr	f			/ as also is...
.endif

.if	leftarrow-1
plot36:	mov	$cplot36,r0
	jbr	f
factor:	mov	$cfactor,r0
	jbr	f
.endif

/ 
/	subroutine line(xarr,yarr,npts1,inc1,ndp,is1)
.if	leftarrow
_line:
	mov	10(sp),r0	/ get kcycle
	mov	6(sp),r1	/ get array size
	bge	1f
	neg	r1
	mov	$1,r0		/ if neg, kcycle is 1
1:	mul	r0,r1		/ total array size is 
	add	r0,r1		/ npts*(kcycle+1)
.endif

.if	leftarrow-1
line:
	mov	*10(r5),r0	/ get kcycle again
	mov	*6(r5),r1	/ array size here also
	bge	1f
	neg	r1
	mov	$1,r0
1:	mul	r0,r1
	asl	r0		/ add 2 arrarys
	add	r0,r1		/ comments as above
.endif

	/ here the array size is in r1
	mov	$Cline,r0
	jbr	FFiiii		/ Float array^2, 4 ints
/ 
/	subroutine offset(xo,xf,yo,yf)
.if	leftarrow
_offset:
.endif

.if	leftarrow-1
offset:
.endif

	mov	$coffset,r0
	jbr	ffff			/ fast-flying-four-floater
/ 
/	subroutine smode(ifa,asp)
.if	leftarrow
_smode:
.endif

.if	leftarrow-1
smode:
.endif

	mov	$csmode,r0
	jbr	if
/ 
/	subroutine speed(i,iarr)
.if	leftarrow
_speed:	clr	r1
	mov	2(sp),r0
	blt	1f		/ if negative, no bull
	mul	$9.,r0		/ low order goes in r1... where we want
1:
.endif

.if	leftarrow-1
speed:	clr	r1
	mov	*2(r5),r0
	blt	1f
	mul	$9.,r0
1:
.endif

	mov	$cspeed,r0
	jbr	iI		/ int-Int array
/ 
/	subroutine axis(xpage,ypage,mesbuf,nchar1,axlen,angl1,
/			firval,delval)
/	subroutine iaxis .....
.if	leftarrow
_axis:	mov	$caxis,r0
	br	1f
_iaxis:	mov	$ciaxis,r0
1:	mov	24(sp),r1
	bge	1f
	neg	r1
1:
.endif

.if	leftarrow-1
axis:	mov	$caxis,r0
	br	1f
iaxis:	mov	$ciaxis,r0
1:	mov	*10(r5),r1
	bge	1f
	neg	r1
1:
.endif

	jbr	ffCiffff	/ yes folks, here you see it
/ 
/	subroutine symbol(x1,y1,size1,mesbuf,angle,ibsiz)
.if	leftarrow
_symbol:
	stfps	r0		/ save the fp status
	setf
	tstf	22(sp)
	mov	44(sp),r1	/ get the arg
	cfcc			/ note the overlap....
	bge	1f		/ see about now
	asl	r1		/ nope, 1 char/ wd so DOUBLE the thing
1:	ldfps	r0		/ restore the old stuff
.endif

.if	leftarrow-1
symbol:	ldfps	r0
	setf
	tstf	*6(r5)		/ check it out
	mov	*14(r5),r1	/ get n
	cfcc
	bge	1f
	asl	r1
1:	ldfps	r0
.endif

	mov	$csymbol,r0
	tst	r1
	ble	fffifi		/ if neg or zero, we ship an int
	jbr	fffCfi		/ otherwise, the char string
/	subroutine number(x,y,size1,fnum1,angle,ndec1)
.if	leftarrow
_number:
.endif

.if	leftarrow-1
number:
.endif

	mov	$cnumber,r0
	jbr	fffffi
/ 
/	In the following, we will Wait for THREE args
/	back in both cases (to make life a little easier)
/	the fffw and FFiiw routines will both dump
/	three floats at the contents of the three locations
/	in fppnt block
/ 
/ *	subroutine scale(array,axlen,npts,inc1)
.if	leftarrow
_scale:	mov	14(sp),r0
	mov	2(sp),-(sp)		/ and the array
	mov	20(sp),r1		/ and kcycle
.endif

.if	leftarrow-1
scale:	mov	*6(r5),r0
	mov	2(r5),-(sp)
	mov	*10(r5),r1		/ kcycle again
.endif

	bge	1f			/ positive...
	neg	r1
1:	asl	r1			/ adjust to floats
	asl	r1
	mov	r1,-(sp)		/ stash it away
	mul	r0,r1			/ and an odd register multipy
	add	2(sp),r1		/ convert to actual pointer
	mov	r1,fltdmp		/ and stash it
	add	(sp),r1			/ get the next(npts*(|kcycle|+1))
	mov	r1,fltdmp+2
	mov	$fltdmp,fltdmp+4
	add	(sp)+,r1		/ r1-arraybase is size of float ship
	sub	(sp)+,r1
	asr	r1
	asr	r1
	mov	$cscale,r0
	jbr	Ffiiw			/ Float array, float, int, int, Wait

/ *	subroutine where(x,y,fact1)
/ *	int	where(&float,&float,&float);
/ no need to ship stuff here.....
.if	leftarrow
_where:	mov	sp,r0
	tst	(r0)+
	mov	$fltdmp,r1
	mov	(r0)+,(r1)+
	mov	(r0)+,(r1)+
	mov	(r0)+,(r1)+
	jbr	noargs_w
.endif

.if	leftarrow-1
where:
	mov	r5,r0
	tst	(r0)+
	mov	$fltdmp,r1
	mov	(r0)+,(r1)+
	mov	(r0)+,(r1)+
	mov	(r0)+,(r1)+
	jbr	noargs_w
.endif


    .bss
tmploc: .=.+2
    .text







/ 




////////////////////////////////////////////////////////////
/ 
/ Now the second level set of routines, the ones
/	that are like i, ffii, etc
/	all expect that they get the op code in r0
/	and the array size (if any) in r1.
/ 
/	That is about  all
/ 
/	docommand returns with a pointer to the
/	"current" arg in r0. This is preserved by
/	the other stuff
/	if there is no plot action, it merely returns
/	to the caller of the whole mess by
/	poping the stack and popj'ing
////////////////////////////////////////////////////////////


i:	mov	$4,-(sp)	/ 4 additional bytes
	jsr	pc,docommand
	jbr	i1		/ and go to common stuff

ii:	mov	$10,-(sp)	/ 10 additional bytes
	jsr	pc,docommand
	jbr	i2		/ common exit again

noargs:	clr	-(sp)		/ noargs does what it says
	jsr	pc,docommand
	rts	pc

noargs_w:	clr	-(sp)	/ again, nothing to send
	jsr	pc,docommand
	jsr	pc,Wait
	rts	pc

f:	mov	$6,-(sp)	/ one float
	jsr	pc,docommand
	jbr	f1



ffff:	mov	$[6*4],-(sp)	/ fast-flying-four-floater
	jsr	pc,docommand
	jbr	f4		/ go to common stuff

if:	mov	$[4+6],-(sp)	/ int then float
	jsr	pc,docommand
	jsr	pc,do_i
	jsr	pc,do_f
	rts	pc

iCi:	inc	r1
	bic	$1,r1
	mov	r1,-(sp)
	add	$12,(sp)
	jsr	pc,docommand
	jsr	pc,do_i
	jsr	pc,do_C
	jbr	i1


iI:	mov	r1,-(sp)	/ int-Int array
	asl	(sp)
	add	$6,(sp)		/ 2 for overhead
	jsr	pc,docommand
	jsr	pc,do_i
	jsr	pc,do_I
	rts	pc



fffifi:
	mov	$[6+6+6+4+6+4],-(sp)
	jsr	pc,docommand
	jsr	pc,do_f
	jsr	pc,do_f
	jsr	pc,do_f
	jsr	pc,do_i
	jbr	f1i1

fffCfi:
	inc	r1
	bic	$1,r1
	mov	r1,-(sp)
	add	$[6+6+6+2+6+4],(sp)
	jsr	pc,docommand
	jsr	pc,do_f
	jsr	pc,do_f
	jsr	pc,do_f
	jsr	pc,do_C
	jbr	f1i1


ffi:	mov	$[6+6+4],-(sp)
	jsr	pc,docommand
	jbr	f2i1

fffffi:
	mov	$[6+6+6+6+6+4],-(sp)
	jsr	pc,docommand
	jsr	pc,do_f
	jsr	pc,do_f
	jsr	pc,do_f
f2i1:	jsr	pc,do_f
f1i1:	jsr	pc,do_f
	jbr	i1

Ffiiw:	mov	r1,-(sp)	/ Float array, float, int, int, Wait
	asl	(sp)
	asl	(sp)
	add	$[2+6+4+4],(sp)
	jsr	pc,docommand
	jsr	pc,do_F
	jsr	pc,do_f
	jsr	pc,do_i
	jsr	pc,do_i
	jsr	pc,Wait
	rts	pc




FFiiii:	mov	r1,-(sp)	/ Float array^2, 4 ints
	asl	(sp)
	asl	(sp)		/ to float
	asl	(sp)		/ two arrays worth
	add	$[2+2+4+4+4+4],(sp)
	jsr	pc,docommand
	jsr	pc,do_F
	jsr	pc,do_F
i4:	jsr	pc,do_i
i3:	jsr	pc,do_i
i2:	jsr	pc,do_i
i1:	jsr	pc,do_i
	rts	pc		/ all gone....


ffie:	mov	$[6+6+4],-(sp)
	jsr	pc,docommand
	jsr	pc,do_f
	jsr	pc,do_f
	jsr	pc,do_i
1:	sys	wait
	bcs	2f
	cmp	r0,am_plotting
	bne	1b
2:	rts	pc


ffCiffff:
	inc	r1
	bic	$1,r1		/ make sure is even from now on
	mov	r1,-(sp)	/ push on stacker
	add	$[6+6+2+4+6+6+6+6],(sp)
	jsr	pc,docommand
	jsr	pc,do_f
	jsr	pc,do_f
	jsr	pc,do_C
f4i1:	jsr	pc,do_i
f4:	jsr	pc,do_f
f3:	jsr	pc,do_f
f2:	jsr	pc,do_f
f1:	jsr	pc,do_f
	rts	pc

/ 
////////////////////////////////////////////////////////////
/ 
/	Now the very-primitives.....
/	docommand
/	pltinit
/	do_f
/	do_i
/	do_F
/	do_I
/	do_C
/	Wait
/ 
/	All these routines (save pltinit) cannot clobber any register
/	except 0, where it leaves the current arg pointer
/	(updated, probably)
/	there is a very heavily write call that does
/	almost all the actual work
/ 
////////////////////////////////////////////////////////////


/ easy(er) first
/ 
do_f:	
	mov	$at4,writaddr
	mov	$2,writcont
	jsr	pc,writeit
.if	leftarrow
	mov	r0,writaddr
	mov	$4,writcont
	add	$10,r0		/ floats go as doubles in c
	jbr	writeit
.endif

.if	leftarrow-1
	mov	(r0)+,writaddr
	mov	$4,writcont
	jbr	writeit
.endif


do_i:
	mov	$at2,writaddr
	mov	$2,writcont
	jsr	pc,writeit
.if	leftarrow
	mov	r0,writaddr
	tst	(r0)+
.endif

.if	leftarrow-1
	mov	(r0)+,writaddr
.endif

	mov	$2,writcont
	jbr	writeit

do_I:	asl	r1		/ tmp, only
	jsr	pc,do_array
	asr	r1
	rts	pc

do_F:	asl	r1
	asl	r1
	jsr	pc,do_array
	asr	r1
	asr	r1
	rts	pc

do_C:
do_array:
	mov	r1,-(sp)
	mov	sp,writaddr
	mov	$2,writcont
	jsr	pc,writeit
	tst	(sp)+
	mov	(r0)+,writaddr
	mov	r1,writcont
	jbr	writeit

    .data
at2:	2
at4:	4
    .text
writeit:	mov	r0,-(sp)
	mov	zpipeout,r0
	sys	0; writcmn
	bcc	1f
	mov	$1,r0
	sys	write; 7f; 6f-7f
.data
7:	<Can't write on child's plotter pipe\n>
6:
	.even
.text
1:	mov	(sp)+,r0
	rts	pc

Wait:	mov	r0,-(sp)
	mov	zpipein,r0
	sys	read; recbuf; [4+4+4]
	bcc	1f
	mov	$1,r0
	sys	write; 7f; 6f-7f
.data

7:	<Can't read information from child\n>
6:
	.even
.text
1:	mov	r1,-(sp)
	mov	r2,-(sp)
	mov	$fltdmp,r0
	mov	$recbuf,r1
	mov	(r0)+,r2
	mov	(r1)+,(r2)+
	mov	(r1)+,(r2)+
	mov	(r0)+,r2
	mov	(r1)+,(r2)+
	mov	(r1)+,(r2)+
	mov	(r0)+,r2
	mov	(r1)+,(r2)+
	mov	(r1)+,(r2)+	/ only marginally worth a loop
	mov	(sp)+,r2
	mov	(sp)+,r1
	mov	(sp)+,r0
	rts	pc		/ and now off to do your stuff



docommand:
	tst	am_plotting
	beq	9f		/ if plotting, don't mess with
				/ me
	mov	2(sp),recbuf+4
	mov	r0,recbuf+2
	mov	$-1,recbuf	/ keep honest
	mov	(sp)+,(sp)	/ and pop
	mov	$recbuf,writaddr
	mov	$6,writcont
	jsr	pc,writeit
.if	leftarrow
	/ c type call
	/ stack has call to docommand
	/	    call to subrs
	/	    first arg
	mov	sp,r0
	cmp	(r0)+,(r0)+
	rts	pc
.endif

.if	leftarrow-1
	/ fortran type call
	/	2(r5) is first arg
	mov	r5,r0
	tst	(r0)+
	rts	pc
.endif

9:	tst	(sp)+
	rts	pc		/ off to the main probably



    .bss
fltdmp:	.=.+6
recbuf: .=.+4+4+4
zpipein: .=.+2
zpipeout: .=.+2
am_plotting: .=.+2
    .data
writcmn:
	sys	write; writaddr: .. ; writcont: ..



    .text
/ / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / 
/ Pltinit sets up 2 pipes, forks, does some nasty's and
/ makes everyone happy
/ 
/ / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / 
	dup = 41.
	pipe = 42.

pltinit:
	tst	am_plotting
	bne	9f		/ no nee to bother him
	sys	signal; 14.; 1	/ ignore eop's (maybe)
	bit	$177776,r0	/ anything cept odd we re-sig
	bne	1f		/ skip that code
	mov	r0,2f
	sys	0; 3f
.data
3:	sys	signal; 14.; 2:..
.text
1:	sys	pipe		/ get 2 pairs
	bcs	8f		/ halts for now
	mov	r0,zpipein	/ read becomes the in des
	mov	r1,-(sp)	/ will become his write des
	sys	pipe
	bcs	8f		/ same sort of comments
	mov	r1,zpipeout
	mov	r0,-(sp)	/ and this becomes his read
1:	sys	fork		/ well, bye for now
	br	5f		/ new proc forever
	bcs	1b		/ no fork action, try again
	mov	r0,am_plotting	/ now we are set up
	mov	(sp)+,r0
	sys	close
	mov	(sp)+,r0
	sys	close
9:	rts	pc		/ and that is all

5:	/ we adjust pipe stuff so that 3 is read
	/ four is write
	/ gotta close the two "other" descriptors first,
	/ though to make room
	mov	zpipein,r0
	sys	close
	mov	zpipeout,r0
	sys	close
	mov	$3,r0		/ now see about read
	cmp	(sp),r0
	beq	1f		/ yep...
	sys	close
	mov	(sp),r0
	sys	dup
1:	mov	$4,r0
	cmp	2(sp),r0	/ is the write already 4???
	beq	1f		/ dynamite
	sys	close
	mov	2(sp),r0
	sys	dup		/ gotta work
1:	mov	$15.,r1		/ close out everything else
1:	mov	r1,r0
	sys	close
	dec	r1
	cmp	r1,$4
	bhi	1b		/ really
	sys	exec; 3f; 2f
	mov	$1,r0
	sys	write; 5f; 6f-5f
	sys	exit
.data
5:	<Can't exec plotter spooler\n>
6:
	.even
.text
  .data
3:/	</bin/cdb\0>
4:	</sys/zeta/source/pltdvr\0>
	.even
2:	3b
	4b
	0
.text
8:	mov	$1,r0
	sys	write; 2f; 3f-2f
	sys	exit
.data
2:	<Cannot open pipes to plotter\n>
3:
	.even
