

PC(I)                       03/05/77                        PC(I)


NAME
       pc - PASCAL-U compiler

SYNOPSIS
       pc [-lpc12rx] file.p [arg1 ...]

DESCRIPTION
       pc  is  the  UNIX pascal compiler. It has an optional flag
       argument.
       If  no  flags are given, pc compiles the program on file.p
       and leaves the bsc-code on file.b. Diagnostics are written
       to  standard  output.   The effect of the flags is as fol-
       lows:

       -l  produces a complete listing of the program with error
	  indications and explained error messages.

       -p  makes a partial listing. Only the erroneous lines are
	  listed.

       -c  suppresses code generation, does a syntax and semantic
          check only.

       -1 performs pass1 of the compiler, leaves the intermediate
          (sc) code on file.i .Pass2 is suppressed, unless the -2
          flag is given.

       -2 executes pass2 of the compiler and leaves interpretable
          bsc-code  on  file.b.   If given without the -1 flag it
          expects its input on file.i rather than file.p.

       -r  runs  the  compiled program by calling the interpreter
          with file.b as codefile.  Arguments given after  file.p
          are passed.

       -x invokes sc-code expansion.(not yet implemented)

       After an error is detected during pass1, the code generation
       is suppressed.

       The main differences from standard PASCAL are:
       1. The  program has no other file than those in  the  pro-
          gram heading, which have type text.There may be at most
          eight files, including the predeclared files input  and
          output,  which  are  associated with standard input and
          output.

       2. Formal  parameters must not be functions or procedures.

       3. All  records are packed. The procedure  unpack  is  not
          available.

       4. The  maximum length of string constants is 80.

       5. The  ordinal value of a set element  must lie between 0

                              - 1 -





PC(I)                       03/05/77                        PC(I)


          and 63 inclusive.

       6. A  goto  may  not lead out of a  procedure  or function
          body.

       7. After  reset a call of  get is  necessary to initialize
          the buffer of a non-standard inputfile.

       8. The procedure dispose is not available. Mark and release
	  are added to manipulate the heap:
	  mark(anyptr)		puts the top of heap address in anyptr.
	  release(anyptr)	restore the top of heap from anyptr.


FILES
       file.p  source file
       file.i  intermediate sc-code
       file.b  bsc-code, interpretable by pi.
       /lib/ppass1 pass1
       /lib/ppass2 pass2
       /lib/pclist error diagnostics
       /usr/bin/pi interpreter

SEE ALSO
       pi (I), PASCAL-U1 documentation, PASCAL user manual.

DIAGNOSTICS
       The  diagnostics  are  intended  to  be  self-explanatory.
       "Memory Fault" may be given if space is exhausted.

BUGS
       Reals can only be written  in  E-format.   Runtime  checks
       are   not  implemented.   Omitting the filename in read or
       write may give problems.  Empty fields in records and emp-
       ty  statements  can give messages.  Writeln and readln re-
       quire always a parameterlist .




















                              - 2 -



