#
/* written by alfred d. whaley, univ of illinois */
#define kack 0166
char ackmsg[2] {
	kack,
	'\n'
};
#define knack 0167
char nackmsg[2] {
	knack,
	'\n'
};
#define ktxt 0170
#define kbin 0171
#define kdone 0172
#define kdata 0173
#define kstop 012

int outbuf[259];

int fd;

int sumchk 0;

int t 0;	/* test mode flag */

#define bufl 512
char buf[bufl];
char ebuf[bufl];
char *bufp;

int stat[3] { 0, 0100000, 0 };
int stat2[3] { 0, 060000, 04 };
int ostat[3];

main (argc,argv) int argc; char **argv; {
	int i,j,k,l;
	int c;
	char *cp;
	int fdata;
	register len;
	int kill();

	if (argc > 1 && compar("-t",argv[1])) {
		argc--;
		argv++;
		t = 1;	/* set diagnostic flag */
	}
	if (argc<2 | argc>3) {
		printf ("type rcv <filename>\n");
		exit();
	}
	fd = open ("/dev/prtaf",2);
	if (fd < 0) {
		printf ("can not open CAC\n");
		exit();
	}
	gtty (fd,ostat);
	stty (fd,stat);
	signal (2, kill);	/* if killed, kill other side */
	write (fd,"\nslvxmit ",9);
	cp = argv[1];
	while ((c = *cp++)) write (fd,&c,1);
	write (fd,"\n",1);
	getsync();
	if (t) printf ("synched\n");
	if ((c=ans()) != kack) {
		if (c != knack) bdsync(c);
		printf ("file not found\n");
		fexit();
	}
	if (t) printf ("file found\n");
	if (argc == 2)
		fdata = fcreat (argv[1],&outbuf);
	else
		fdata = fcreat (argv[2],&outbuf);
	if (fdata < 0) {
		printf ("can not create file\n");
		kill();
	}
	for (;;) {
		if ((c = ans()) != kdata) break;
		sack();
		len = read (fd,&buf,bufl);
		while (!tsum(len)) {
			printf ("sumcheck error\n");
			snack();
			len = read(fd,&buf,bufl);
		}
		sack();
	if (t) printf ("rec recvd ok\n");
		bufp = &buf[2];
		len =- 3;
		while (len--) {
			file (*bufp++);
		}
	}
	if (c != kdone) bdsync(c);
	fflush (outbuf);
	close (fdata);
	fexit();
}

sack () {
	write (fd,ackmsg,2);
}

snack () {
	write (fd,nackmsg,2);
}

int save;
int flipflop 0;
int binary;
file (c) char c; {
	int k;
	k = c&0177;
	if (k == kbin) binary = 1;
	else if (k == ktxt) binary = 0;
	else if (k == kstop) return;
	else {
		if (binary) {
			if (flipflop++ == 1) {
				flipflop = 0;
				putc (save | ((k&017) << 4),outbuf);
			} else save = k&017;
		} else putc (k,outbuf);
	}
}

int rbuf;
int ans () {
	read (fd,&rbuf,2);
	return (rbuf&0177);
}

bdsync (c) int c; {
	printf ("out of sync\n");
	if (t) printf ("sync char is %o\n",c);
	if (t) printf ("rbuf is %o\n",rbuf);
	kill();
}

kill () {
	write (fd,"bleep",5);	/* make him be gone */
	fexit();
}

getsync () {
	sleep(4);
	read (fd,&buf,1);	/* discard all chars that came in */
	stty (fd,stat2);	/* set ctrl char wakeup */
	sack();
}

int erfl 0;
int tsum(len) int len; {
	int tchk;
	int tchk2;
	int tstsum;
int i;
	tchk = (buf[0]&017) + ((buf[1]&017)<<4);
	bufp = &buf[2];
	tchk2 = 0;
	while (bufp < &buf[len-1]) {
		tchk2 =+ *bufp++ & 0177;
	}
	tstsum = (tchk2 + sumchk) & 0377;
	if (tchk == tstsum) {
		sumchk = tstsum;
if (erfl) {
	erfl = 0;
for (i=0;i<len;i++) if (buf[i] != ebuf[i]) {
	if (t) printf ("byte %d gud=%o bad=%o",i,buf[i],ebuf[i]);
	if (t) printf (" gud+=%o gud-=%o",buf[i+1],buf[i-1]);
	if (t) printf (" gud++=%o gud--=%o\n",buf[i+2],buf[i-2]);
}
}
		return(1);
	}
for (i=0;i<len;i++) ebuf[i] = buf[i];
erfl = 1;
	return(0);
}

compar(s1,s2) char *s1,*s2; {
	while (*s1++ == *s2)
		if (*s2++ == '\0') return (1);
		return (0);
	}

fexit () {
	stty (fd,ostat);
	exit();
}
