#
/* written by alfred d. whaley, univ of illinois 1976 */
#define kack 0166
#define knack 0167
#define ktxt 0170
#define kbin 0171
#define kdone 0172
#define kdata 0173
#define kstop 012

int sumchk 0;

#define bfsz 128
int bufsize bfsz;
char buf[bfsz];
char *bufp &buf[2];
int binary 0;
int bcnt;
int fdata;
int fd;		/* file descr to cac */
int t;		/* test flag */
char cmd;

int inbuf [259];

int ostat[3];
int stat[3] {0, 0100000, 04};	/* slow command mode 1200b */
int fstat[3] {04, 060000, 04};	/* fast xfer 9600b mode */

main(argc,argv)
int argc; char *argv[];
{
	register int c;
	char *cp;
	int kill();

	if (argc > 1 && compar("-t",argv[1])) {
		argc--;
		argv++;
		t = 1;	/* set diagnostic flag */
	}
	if (argc < 2 || argc > 3) {
		printf ("type xmit <filename>\n");
		exit();
	}
	if (fopen (argv[1], inbuf) < 0) {
		printf ("No %s\n", argv[1]);
		exit(-1);
	}
	fd = open ("/dev/prtaf",2);
	if (fd < 0) {
		printf ("can not open CAC\n");
		exit();
	}
	if (t) printf ("starting sttys\n");
	gtty (fd,ostat);
	stty (fd,stat);
	signal (2, kill);
	write (fd,"\nslvrcv ",8);
	cp = argv[argc-1];
	while (*cp++);
	write (fd, argv[argc-1], cp-argv[argc-1]-1);
	write (fd,"\n",1);
	if (t) printf ("command sent\n");
	getsync();

/* transfer file */
	while ((c = getc(inbuf)) >= 0) {
		putcx(c);
	}
	if (bufp > &buf) send();
	done();
	stop();
}
char datamsg[2] {
	kdata,
	'\n'
};

send () {
	int len;
	if (t) printf ("send\n");
	write (fd,datamsg,2);
	ack();
	len = bufp - &buf + 1;
	*bufp = kstop;
	buf[0] = (sumchk&017) | 0140;
	buf[1] = ((sumchk>>4)&017) | 0140;
	do write (fd,&buf,len); while (!tack());
	bufp = &buf[2];
}

putcx (c) int c; {
	if (binary) {
		if (bchr(c)) bcnt=0;
		else 
			if (++bcnt > 2) {
				binary = 0;
				putcy(ktxt);
			}
	} else if (bchr(c)) {
		putcy(kbin);
		binary = 1;
		bcnt = 0;
	}
	if (binary) {
		putcy ((c&017) | 0140);
		putcy (((c>>4)&017) | 0140);
	} else putcy (c);
}

putcy (c) int c; {
	if (bufp>=&buf[bufsize-1]) {
	send();
	}
	sumchk =+ c;
	*bufp++ = c;
}

bchr (c) int c; {
	if (c < 040 || c >= 0166) return (1);
	else return (0);
}

ack () {
	if (!tack()) bdsync();
	if (t) printf ("ack\n");
}

int tack () {
	int answer;
	read (fd,&answer,2);
	answer =& 0177;
	if (answer == kack) return(1);
	if (answer == knack) return(0);
	bdsync();
}

stop () {
	stty (fd,ostat);
	exit();
}

char sackmsg[2] {
	kack,
	'\n'
};
char snackmsg[2] {
	knack,
	'\n'
};

sack () {
	write (fd,&sackmsg,2);
}

snack () {
	write (fd,&snackmsg,2);
}

char donemsg[2] {
	kdone,
	'\n'
};

done() {
	write (fd,&donemsg,2);
}

bdsync () {
	done();
	sleep (2);
	printf ("out of sync\n");
	stop();
}

kill () {
	write (fd, "bleep*\n", 7);	/* tell him to go away */
	stop();
}

getsync () {
	int c;
	int ackct;
	int i;
	int len;
	char rb[50];
	sleep (2);
	stty (fd, fstat);
	for (;;) {
		len = read (fd, rb, 50);
		if (t) {
			printf ("msg rcvd:\n");
			for (i=0; i<len; i++)
				printf ("%o ", rb[i]);
			printf ("\n");
		}
		ackct = 0;
		for (i=0; i<len; i++) {
			c = rb[i];
			if (c == '\n') goto fin;
			if (c == kack) ackct++;
			else ackct = 0;
		}
		if (t) printf ("no car ret\n");
		continue;
	    fin:
		if (t) printf ("car ret\n");
		if (ackct == 4) break;
		if (t) printf ("not 4 acks\n");
	}
}
compar(s1,s2) char *s1,*s2; {
	while (*s1++ == *s2)
		if (*s2++ == '\0') return (1);
		return (0);
	}
