#include "hsh.h"

err(s)
char *s;
{

	/* if arg != -1, print error message and a newline */
	/* in any case, flush input if coming from command file */
	/* and if not a fork of main shell, reset. */
	/* otherwise, exit with special code which says to parent */
	/* to continue the process of flushing the input */
	/* hence, if the command "a; b; c" is given, and a bombs out */
	/* b and c are not executed. */

	/* this routine never returns */

	if (s != -1) {
		prs(s);
		prs(NEWLINE);
	}
	peekc = 0;
	if(promp == 0) {
		seek(0, 0, 2);
		eof();
	}
	if (noreset == 0) reset();	/* pull a reset if main shell */
	/* if fork of main shell, exit with special code */
	exit(ERREXIT);
	/* will not return */
}

pwait(i, t)
int i, *t;
{
	register p, e;
	int s;
	char eflag;

	eflag = 0;
	if(i != 0)
	for(;;) {
		times(&timeb);
		time(&timeb.proct);
		p = wait(&s);
		if(p == -1)
			break;
		e = s&0177;
		if (e > MAXSIG || mesg[e] != 0) {
			if(p != i) {
				prn(p);
				prs(": ");
			}
			if (e > MAXSIG) {
				/* to be perfectly correct */
				/* a check should be made */
				/* to see if e == 0177, and if so */
				/* ptrace(8, p, 0, 0) */
				/* this causes trouble at harv/unix */
				/* because we implemented "break" key as */
				/* signal # -1  (a bit of a booboo) */
				prs("Sig ");
				prn(e);
			} else prs(mesg[e]);

			if(s&0200)
				prs(" -- Core dumped");
			prs(NEWLINE);
		}
		/* force exit with err if bad exit status code */
		if (e != 0 || s.hibyte == ERREXIT) eflag++;
		if(i == p) {
			acct(t);
			/* pick up new tty mode if stty executed */
			/* this prevents unintended mucking up of the mode */
			if (equal(t[DCOM], "stty") ||
				equal (t[DCOM], "STTY")) gtty(2,ttmode);
			break;
		} else
			acct(0);
	}
	if (eflag) err(-1);	/* error exit if any progs bombed */
}

