#include "/h/stat.h"

/* this little program exits with 0 if file1 is newer than file2 */
/* and hence this kind of thing will work: */
/*  if { newer $1.c $1.o } cc -c $1.c    */
/* if both files are non-existent, an error is given */
/*  otherwise, the non-existent file is assumed to be older */

main(argc, argv)
char **argv;
{
	static struct inode statb;
	long moddate;

	if (argc != 3) error("use: newer file1 file2");
	statb.i_mtime = 0;
	stat(argv[1], &statb);
	moddate = statb.i_mtime;
	statb.i_mtime = 0;
	stat(argv[2], &statb);
	if (moddate == 0 && statb.i_mtime == 0) error("files non-existent");
	exit(moddate > statb.i_mtime? 0: -1);
}
